

import ddf.minim.*;
import de.looksgood.ani.*;
import de.looksgood.ani.easing.*;

import processing.serial.*;
import cc.arduino.*;

Arduino arduino;


PFont font;
PImage backgroundImage;

PShape scoreText; // 
PShape gameOn; // 
PShape comboImages1[] = new PShape[5];// images for Up the Line combo
PShape comboImages2[] = new PShape[5];// images for Around the World combo
PShape comboImages3[] = new PShape[4];// images for Because We Can combo
PShape ballsText; //  
PShape streakText; // 
PShape dontPanic; // 


PShape bonusBallPoint50L; // 
PShape bonusBallPoint50R; // 
PShape bonusBallPoint100L; // 
PShape bonusBallPoint100R; // 

PImage bonusBall50; // 
PImage bonusBall100; // 

//audio initializing
Minim minim;
AudioPlayer introMusic;
Minim minim2;
AudioPlayer hole_chaching;
Minim dontPanic_sound;
AudioPlayer dontPanic_play;
Minim becauseWeCan_sound;
AudioPlayer becauseWeCan_play;

color off = color(4, 79, 111);          //colors for button status boxes
color on = color(84, 145, 158);
int  holePin[] = {
  2, 3, 4, 5, 6, 7, 8
};    // the pins that the switches are attached to 
int  holeValue[] = {
  10, 20, 30, 40, 50, 100, 100
};
int  streakValue[] = {
  0, 10, 15, 25, 35, 80, 80
};                                        //streak values for each hole. Get bigger with hole value
int  combo[] = {
  0, 0, 0, 0, 0, 0, 0
};                                        //markers for whether hole has been hit

int monScale = 2;  //2 for 720p, 3 for 1080p

int combo_image1_1;
int combo_image1_2;
int combo_image1_3;
int combo_image1_4;
int combo_image1_5;
int combo_image1_6;
int combo_image1_7;
int combo_image1_8;

//target of pieces of combo1 image. x,y coords of uper left corner
int combo1_target[] = {
  25*monScale, 25*monScale
};

int combo_image2_1;
int combo_image2_2;
int combo_image2_3;
int combo_image2_4;
int combo_image2_5;
int combo_image2_6;
int combo_image2_7;
int combo_image2_8;

//target of pieces of combo2 image. x,y coords of uper left corner
int combo2_target[] = {
  25*monScale, 60*monScale
};

int combo_image3_1;
int combo_image3_2;
int combo_image3_3;
int combo_image3_4;
int combo_image3_5;
int combo_image3_6;


//target of pieces of combo3 image. x,y coords of uper left corner
int combo3_target[] = {
  150*monScale, 15*monScale
};

int ballCount;                             //balls left to play
int ballInPlay;
int newScore=0;                              //game score
int score=0;                                 //game score
int scoreJump = 100;                         //jump in score on hitting target
int streak=1;                                //number of times current hole has been hit in a row
int lastHole=0;                              //last hole hit
int[] gameRecord=new int[11];
int[] runningTotal=new int[11];

int comboTarget=0;                           //target to hit for combo bonus points
int comboBonus=0;                            //bonus for hitting comboTarget
int lastTime;                                //timer for target switches to reset
int introTime;                               //timer for "Game On!" message
int comboTimer[] = {
  0, -10000, -10000, -1, -1, -1
};        //timer for combo messages
int endTimer=1000000;
int introFade;
int introSlide;
int combo1;
int combo2;
int combo4;
int combo5;
int combo6;

String backRand;

float easing=.05;
float xGameOn;                               //x location of "Game On!" message
final int DELAY_TIME = 1000;                 //Time for switch reset
final int GAME_INTRO = 2500;                 //Time for "Game On!" message
final int COMBO_TIMER[] = {
  0, 4000, 4000, 6000, 1500, 3000
};                 //Time for combo1 message



void setup() {
  size(640*monScale, 360*monScale);
  smooth();
  arduino = new Arduino(this, Arduino.list()[4], 57600);
  font = loadFont("SansSerif-48.vlw");
  textFont(font);
  ballCount=0;

  for (int i = 2; i <= 9; i++)
    arduino.pinMode(i, Arduino.INPUT);

  lastTime = millis();




  //picking a random image from library
  backRand = "back" + int(random(8)) + ".gif";
  backgroundImage = loadImage(backRand);

  // Loading up all the number images, 0-9, into image array
  for (int i=0; i<10; i++) {
    String imageLoad = "carnival_numbers_" + i + ".svg";
    img[i] = loadShape(imageLoad);  // Load the image into the program
  }

  // Loading up combo2 images
  for (int i=1; i<5; i++) {
    String imageLoad = "combo1_" + i + ".svg";
    comboImages1[i] = loadShape(imageLoad);  // Load the image into the program
  }


  // Loading up combo2 images
  for (int i=1; i<5; i++) {
    String imageLoad = "combo2_" + i + ".svg";
    comboImages2[i] = loadShape(imageLoad);  // Load the image into the program
  }

  // Loading up combo2 images
  for (int i=1; i<4; i++) {
    String imageLoad = "combo3_" + i + ".svg";
    comboImages3[i] = loadShape(imageLoad);  // Load the image into the program
  }


  scoreText = loadShape("carnival_score.svg"); 
  gameOn = loadShape("gameon_big.svg"); 
  ballsText = loadShape("message_balls.svg"); 
  streakText = loadShape("message_streak.svg"); 
  dontPanic = loadShape("dontpanic.svg"); 
  bonusBall50 = loadImage("bonusball50_back.jpg");
  bonusBall100 = loadImage("bonusball100_back.jpg"); 
  bonusBallPoint50L = loadShape("bonusball_pointer_50_l.svg"); 
  bonusBallPoint50R = loadShape("bonusball_pointer_50_r.svg"); 


  //Setting up scoreImage with all null images
  for (int i=0; i<3; i++) {
    scoreImages[i] = loadShape("carnival_numbers_null.svg");  // Load the image into the program
  }
  scoreImages[3] = loadShape("carnival_numbers_0.svg");

  scoreCenterY = scoreLocationY + numHeight/2;    //setting up center of score, doesn't change

  Ani.init(this);
  minim = new Minim(this);
  minim2 = new Minim(this);
  becauseWeCan_sound = new Minim(this);
  dontPanic_sound = new Minim(this);
}

void draw() {
  if (ballCount==0) {
    arduino.digitalWrite(13, Arduino.LOW);
  }
  else {
    arduino.digitalWrite(13, Arduino.HIGH);
  }
  background(120);
  image(backgroundImage, 0, 0);
  fill(50, 50, 50, 200);
  rect(0, 0, 1920, 1080, 30);
  //Start button function, resets all variables
  if (arduino.digitalRead(9) == Arduino.LOW && ballCount==0) {
    startTheGame();
  }

  //target function, checking for hits and adding to score
  for (int i = 2; i <= 8; i++) {
    if (arduino.digitalRead(i) == Arduino.LOW && ballCount>0 && (millis() - lastTime >= DELAY_TIME)) {

      //hole sound effect
      hole_chaching = minim2.loadFile("chaChing.wav");
      hole_chaching.play();

      //recording holeValue for game record
      gameRecord[ballInPlay]=holeValue[i-2];

      scoreJump = holeValue[i-2];
      ballCount--;
      lastTime=millis();
      combo[i-2]++;

      //streak check
      if (holeValue[i-2]==lastHole && lastHole!=10) {
        scoreJump += streak*streakValue[i-2];
        streak++;
      }
      else { 
        streak=1;
      }

      //this convers the bonus ball effect for a couple combos 
      if (comboTarget!=0) {
        if (holeValue[i-2]==comboTarget) {
          scoreJump=comboBonus;
        }
        else {
          scoreJump=0;
          gameRecord[ballInPlay]=0;
          ballInPlay--;
        }
        streak--;
        comboTarget=0;
      }
      //checks for Around the World combo and Up the Line
      if (combo[0]>0 && combo[1]>0 && combo[2]>0 && combo[3]>0 && combo[4]>0 && combo[5]>0 && combo[6]>0 && combo1==0 && combo2==0) {
        combo3();
      }
      //checks for Around the World combo (all targets)
      if (combo[0]>0 && combo[1]>0 && combo[2]>0 && combo[3]>0 && combo[4]>0 && combo1==0) {
        combo1();
      }
      //checks for Around the World combo (all targets)
      if (combo[0]>0 && combo[1]>0 && combo[2]>0 && combo[3]>0 && combo[4]>0 && combo[5]>0 && combo[6]>0 && combo2==0) {
        combo2();
      }


      //checks for Don't Panic combo - 40, then 20
      if (lastHole==40 && holeValue[i-2]==20 && combo4==0) {
        dontPanic_play = dontPanic_sound.loadFile("dontpanic.mp3");
        dontPanic_play.play();
        combo4();
      }
      //checks for Perfect Game - all 100s
      if (holeValue[i-2]==100 && streak==9) {
        scoreJump+=3997;
        combo6=1;
      }

      //checks for Because We Can combo 
      if (lastHole==10 && holeValue[i-2]==100 && combo5==0) {
        becauseWeCan_play = becauseWeCan_sound.loadFile("becausewecan.mp3");
        becauseWeCan_play.play();
        combo5();
      }

      if (ballCount==0) {
        endTimer=millis();
      }

      newScore += scoreJump;
      runningTotal[ballInPlay]=newScore;      //recording score for game record
      ballInPlay++;                           //incrementing ball in play for gme record
      lastHole=holeValue[i-2];
    }
  }

  //status updates for balls and streak

  shape(scoreText, 20*monScale, 15*monScale, 250*monScale, 70*monScale); 
  shape(ballsText, 20*monScale, 295*monScale, 40*monScale, 40*monScale); 
  shape(img[ballCount], 215*monScale, 285*monScale, 55*monScale, 65*monScale);

  //streak indicator
  if (streak>1) {
    shape(streakText, 330*monScale, 295*monScale, 40*monScale, 40*monScale); 
    shape(img[streak], 570*monScale, 285*monScale, 55*monScale, 65*monScale);
  }

  scoreIncrement();
  scoreImage (score);


  //this makes the score "bounce" when it jumps. The bigger the jump in score the bigger the bounce
  if (angle<3.1) {
    float scalar = 1+(sin(angle))*scoreJump/400;
    //shifting so score scales from center, not origin
    pushMatrix();
    translate(scoreCenterX*(1-scalar), scoreCenterY*(1-scalar));
    scale(scalar);
    scoreDisplay();
    popMatrix();
    angle+=speed;
  }
  else
    scoreDisplay();

  //"Game On!" message display
  if (millis() - introTime <= GAME_INTRO) {
    textSize(72);
    fill(50, 50, 50, 100);
    rect(0, 0, 1920, 1080, 30);
    float targetX = 80*monScale;        //end x location for message
    xGameOn += (targetX - xGameOn) * easing;
    shape(gameOn, xGameOn, 15*monScale, 50*monScale, 50*monScale);
  }

  comboDisplay();

  //gameStats shows the record of the game played at end
  if ((millis() - endTimer > COMBO_TIMER[3]) && ballCount==0) {  
    gameStats();
  }
}

void gameStats() {
  image(backgroundImage, 0, 0);
  fill(50, 50, 50, 200);
  rect(0, 0, 1920, 1080, 30);
  fill(240);

  textSize(30*monScale);
  for (int i=0;i<11;i++) {
    if (gameRecord[i]!=0) {
      text("Ball ", 12*monScale, 60+30*i*monScale);
      text(i+1, 75*monScale, 60+30*i*monScale);
      text(gameRecord[i], 120*monScale, 60+30*i*monScale);
      text(runningTotal[i], 210*monScale, 60+30*i*monScale);
    }
  }
}


void scoreIncrement() {
  if (score<=newScore-1000) {
    score += 100;
    angle=0.0;
  }
  if (score<=newScore-100) {
    score += 50;
    angle=0.0;
  }
  else if (score<=newScore-10) {
    score += 10;
    angle=0.0;
  }
  else if (score>newScore-9 && score<newScore) {
    score=newScore;
    angle=0.0;
  }
}

void stop()
{
  // always close Minim audio classes when you are done with them
  introMusic.close();
  // always stop Minim before exiting
  minim.stop();

  hole_chaching.close();
  minim2.stop();

  becauseWeCan_play.close();
  becauseWeCan_sound.stop();

  dontPanic_play.close();
  dontPanic_sound.stop();

  super.stop();
}

